# modified from parsePSIBLAST_aln1.awk to include alignment info per NAR reviewer request
# use ptot=p2*pf*[1-log(p2*pf)] if p>0 else if p2=0 or pf=0, ptot=0 (per Gribskov Bioinformatics1998:14)
# instead of our own as follows:
# FOM: p_new=(1-exp(-(subjlen/dbase_len)*psi-eV2))(1-exp(-subjlen/dbase_len)*psi-eVIT_last))
# per www.ncbi.nlm.nih.gov/staff/tao/URLAPI/blastdb.html pg - defline identifier syntax for different dbase
# GenBank (gb);EMBL (emb);DDBJ (dbj); NBRF PIR (pir);Protein Research Found (prf);SWISS-PROT (sp);
# Brookhaven (pdb); Patents (pat); GenInfo Backbone (bbs); General dbase indeitifier (gnl); NCBI Ref (ref); 
# Local Sequence identifier (lcl) && *** GeneInfo (gi)

BEGIN{header="\<\!DOCTYPE html\nPUBLIC \"-\/\/W3C\/\/DTD XHTML 1.0 Transitional\/\/EN\"\n\"http:\/\/www.w3.org\/TR\/xhtml1\/DTD\/xhtml1-transitional.dtd\"\>\n\<html\>\n\<head\>\n\<title\>\<\/title\>\n\<\/head\>\n\<body\>\n";
  flag=0;round=4;count2=0;countfinal=0;IT2hit=" ";aFLAG=0;print header;}
# parse iteration 2 
$0 ~/^Results/ && $4==2 {flag=1;runID=2;}
flag==1 && runID==2 {
  if($0~/^>gi/||$0~/^>ref\|/||$0~/^>gb/||$0~/^>emb/||$0~/^>dbj/||$0~/^>prf/||$0~/^>pir/||$0~/^>sp\|/||$0~/^>pdb/||$0~/^>pat\|/||$0~/^>bbs/||$0~/^>gnl/||$0~/^>lcl\|/){
    if(aFLAG==1) {print "</PRE>" >> fname; close(fname);}else aFLAG=1;
    ++count2;numAln=0;n=split($0,a,"|");
  if($0~/^>prf/||$0~/^>pir/) {ginumTEMP=a[3];p=split(ginumTEMP,pp," ");ginum1=pp[1];} # per blastHELP - def identifier synax for pir & prf is pir/prf||entry
  else if($0~/^>gi/||$0~/^>ref\|/||$0~/^>gb/||$0~/^>emb/||$0~/^>dbj/||$0~/^>sp\|/||$0~/^>pdb/||$0~/^>pat\|/||$0~/^>bbs/||$0~/^>gnl/||$0~/^>lcl\|/) ginum1=a[2];
  IT2hit=IT2hit""ginum1" ";IT2header[ginum1]=$0;fname="alignments/"ginum1"_IT2.html"; print "<PRE>" >> fname;}
  if(aFLAG==1 && $0!~/Searching/){print $0 >> fname}
  if($0 ~/Length/) {IT2len[ginum1]=$NF;}
   #curr PSI-BLAST: ...Expect = e-138,   Method: Compositional matrix adjust.
  if($0 ~/Expect/) {t1=split($0,tt,",");evstr=tt[2];t2=split(evstr,tt1," ");laste=tt1[t2];
                    numAln++;if(numAln==1){if(laste~/^e/) eV="1"laste; else eV=laste; 
                    IT2eV[ginum1]=eV*1;}}
# end of iteration 2 - reset flag
  if($0 ~/Searching/) {print "</PRE>" >> fname; close(fname);flag=0;aFLAG=0;}
  }

#read in later iterations
$0 ~/^Results/ && $4>2 {flag=2;runID=$NF;for(i=1;i<=countfinal;i++) lastITgi[i]="";countfinal=0;} 
flag==2{
  if($0~/^>gi/||$0~/^>ref\|/||$0~/^>gb/||$0~/^>emb/||$0~/^>dbj/||$0~/^>prf/||$0~/^>pir/||$0~/^>sp\|/||$0~/^>pdb/||$0~/^>pat\|/||$0~/^>bbs/||$0~/^>gnl/||$0~/^>lcl\|/){
    if(aFLAG==1) { print "</PRE>" >> fname;  close(fname); } else aFLAG=1;
    ++countfinal;numAln=0;m=split($1,b,"|");
 if($0~/^>prf/||$0~/^>pir/){ginumTEMP1=b[3];p1=split(ginumTEMP1,ppp," ");ginum2=ppp[1];}
 else if($0~/^>gi/||$0~/^>ref\|/||$0~/^>gb/||$0~/^>emb/||$0~/^>dbj/||$0~/^>sp\|/||$0~/^>pdb/||$0~/^>pat\|/||$0~/^>bbs/||$0~/^>gnl/||$0~/^>lcl\|/) ginum2=b[2];
 lastITgi[countfinal]=ginum2;lastITheader[ginum2]=$0;fname="alignments/"ginum2"_ITfinal.html"; print "<PRE>" >>fname;}
  if(aFLAG==1 && $0!~/non-redundant/){print $0 >> fname;}
  if($0 ~/Length/) {lastITlen[runID,ginum2]=$NF;}
  if($0 ~/Expect/) {t1=split($0,tt,",");evstr=tt[2];t2=split(evstr,tt1," ");laste=tt1[t2];
                    numAln++;if(numAln==1){if(laste ~/^e/) eV="1"laste; else eV=laste;lastITeV[runID,ginum2]=eV*1;}}
  if(($0 ~/Searching/)||($0 ~/non-redundant/ && flag==2)) {print "</PRE>" >> fname; close(fname); flag=0;aFLAG=0;}
}

# get database len
$0 ~/^Matrix/ {flagdb=1;print "END_ALIGNMENT_SECTION";}# this is end of alignment section
{if(flagdb==1 && $0 ~/length of database/) {dbSeq1=$NF;gsub(/,/,"",dbSeq1);dbase_len=dbSeq1*1;flagdb=0;}}
# merge IT2 and final iteration
# get lastIT gi's
END{for(i=1;i<=countfinal;i++) {
     gi_last=lastITgi[i];
     # look for same gi in IT2 - if found, substract it from IT2hit string
     if((gi_last) in IT2eV) {gi_last1=" "gi_last" ";gsub(gi_last1," ",IT2hit);len=IT2len[gi_last];eV2=IT2eV[gi_last];}
     else {len=lastITlen[runID,gi_last];eV2=10000;} #assigned eV=10000 if IT_final hit not in IT2
     #calculate pValue & FOM - ignore changed to modFOM
     if(eV2==0||lastITeV[runID,gi_last]==0) y6=0; #per Gribskov's paper
     else {if(exp(-len/dbase_len*eV2)==1) {y4=-(-len/dbase_len*eV2);}
       else {y4=1-exp(-len/dbase_len*eV2);}
       if(exp(-len/dbase_len*lastITeV[runID,gi_last])==1) y5=-(-len/dbase_len*lastITeV[runID,gi_last]); 
       else y5=1-exp(-len/dbase_len*lastITeV[runID,gi_last]);
       if(y4*y5<1e-10) y6=y4*y5; else y6=-log(1-(y4*y5*(1-log(y4*y5))));
       # calc. mod. ptot =p2*pf*[1-log(p2*pf)]
      # ptot=y4*y5*(1-log(y4*y5));# mod. FOM per NAR's reviewer 1 critique
       # convert to Etot =-N/M*log(1-ptot) the log(1-ptot) part is y6
       #y6=-log(1-ptot);
     }              
     if(eV2<10||lastITeV[runID,gi_last]<10){
        print gi_last,len,eV2,lastITeV[runID,gi_last],dbase_len/len*y6,lastITheader[gi_last];}
     }
  
  
  g=split(IT2hit,notIT2," "); # check not in common list  - what's left in IT2string 
  for(i=1;i<=g;i++){gitemp=notIT2[i];
    #if((gitemp) in IT2len) {
    len=IT2len[gitemp];eV2=IT2eV[gitemp];eV=10000;
    #calculate pValue & FOM
    if(eV2==0||lastITeV[runID,gi_last]==0)y6=0; #per Gribskov's paper
    else {if(exp(-len/dbase_len*eV2)==1) y4=-(-len/dbase_len*eV2);
      else y4=1-exp(-len/dbase_len*eV2);
      if(exp(-len/dbase_len*eV)==1) y5=-(-len/dbase_len*eV);
      else y5=1-exp(-len/dbase_len*eV);
      #if(y4*y5<1e-10) y6=y4*y5; else y6=-log(1-y4*y5);
      if(y4*y5<1e-10) y6=y4*y5; else y6=-log(1-(y4*y5*(1-log(y4*y5))));
      # calc. mod. ptot =p2*pf*[1-log(p2*pf)]
      #ptot=y4*y5*(1-log(y4*y5));# mod. FOM per NAR's reviewer 1 critique
      # convert to Etot =-N/M*log(1-ptot) the log(1-ptot) part is y6
      #y6=-log(1-ptot);
    }
    if(eV2<10||eV<10) {
       print gitemp,len,eV2,eV,dbase_len/len*y6,IT2header[gitemp];}
    }
}
